# NOTE: Derived from blib/lib/ClearCase/Wrapper/MGi.pm.
# Changes made here will be lost when autosplit is run again.
# See AutoSplit.pm.
package ClearCase::Wrapper::MGi;

#line 506 "blib/lib/ClearCase/Wrapper/MGi.pm (autosplit into blib/lib/auto/ClearCase/Wrapper/MGi/_Mkbco.al)"
sub _Mkbco {
  use strict;
  use warnings;
  use File::Copy;
  my ($cmd, @cmt) = @_;
  my $rc = 0;
  my %pbrt = ();
  my $bt = $cmd->{bt};
  my @opts = $cmd->opts;
  if ($cmd->flag('nco')) { #mkbranch
    my @a = ($bt);
    push @a, $cmd->args;
    $cmd->args(@a);
    push @opts, @cmt;
    $cmd->opts(@opts);
    return $cmd->system;
  } elsif ($cmd->flag('branch')) { #co
    push @opts, @cmt;
    $cmd->opts(@opts);
    return $cmd->system;
  }
  die Msg('E', 'Element pathname required.') unless $cmd->args;
  foreach my $e ($cmd->args) {
    my $ver = $cmd->{ver};
    my $typ = $CT->des([qw(-fmt %m)], $e)->qx;
    if ($typ !~ /(branch|version)$/) {
      warn Msg('W', "Not a vob object: $e");
      $rc = 1;
      next;
    }
    if ($ver) {
      $ver = "/$ver" unless $ver =~ m%^[\\/]%;
      $e =~ s%\@\@.*$%%;
      my $v = $e;
      $ver = "$v\@\@$ver";
    } elsif ($e =~ m%^(.*?)\@\@.*$%) {
      $ver = $e;
      $e = $1;
      $ver =~ s%[\\/]$%%;
      $ver .= '/LATEST' if $typ eq 'branch';
    }
    if (!$ver or !$bt) {
      my $sel = $CT->ls(['-d'], $e)->qx;
      if ($bt) {
	$ver = $1 if $sel =~ /^(.*?) +Rule/;
      } elsif ($sel =~ /^(.*?) +Rule:.*-mkbranch (.*?)\]?$/) {
	($ver, $bt) = ($ver? $ver : $1, $2);
      }
    }
    if ($bt and _Checkcs($e)) {
      my $main = 'main';
      if ($CT->des(['-s'], "$e\@\@/main/0")->stderr(0)->stdout(0)->system) {
	$main = ($CT->lsvtree($e)->qx)[0];
	$main =~ s%^[^@]*\@\@[\\/](.*)$%$1%;
      }
      my $vob = $CT->des(['-s'], "vob:$e")->qx;
      my $re = _Pbrtype(\%pbrt, "$bt\@$vob") ?
	qr([\\/]${main}[\\/]$bt[\\/]\d+$) : qr([\\/]$bt[\\/]\d+$);
      if ($ver =~ m%$re%) {
	push @opts, @cmt, $e;
	$rc |= $CT->co(@opts)->system;
      } else {
	my @mkbcopt = @cmt? @cmt : qw(-nc);
	my $out = $cmd->flag('out');
	my $nda = $cmd->flag('ndata');
	copy($e, $out) or die Msg('E', "Failed to create $out: $!") if $out;
	push @mkbcopt, '-nco' if $out or $nda;
	if ($CT->mkbranch([@mkbcopt, '-ver', "/$main/0", $bt], $e)->system) {
	  $rc = 1;
	} else {
	  if ($out or $nda) {
	    my $e0 = "$e\@\@/$main/$bt/0";
	    $rc = $CT->co(['-nda', @cmt? @cmt : '-nc'], $e0)->system;
	  }
	  if ($ver !~ m%\@\@[\\/]${main}[\\/]0$%) {
	    my @o = ('-to', $e);
	    push @o, '-nda' if $out or $nda;
	    my $lrc = $CT->merge([@o], $ver)->stdout(0)->system;
	    unlink glob("$e.contrib*");
	    if ($ENV{FSCBROKER}) {
	      require ClearCase::FixSrcCont; #optional fix of source container
	      ClearCase::FixSrcCont::runfix($ver);
	    }
	    $rc |= $lrc;
	  }
	}
      }
    } else { # Ensure proper treatment of cascading branches
      my @args;
      push @args, @opts, @cmt;
      my $fn = ($cmd->prog())[1]; # Skip 'cleartool'
      if ($fn =~ /^mkb/ and $bt) { # May be abbreviated
	push @args, $bt;
	push @args, $e; # Ensure non empty array
	$rc |= $CT->mkbranch(@args)->system;
      } else {
	push @args, $e;
	$rc |= $CT->co(@args)->system;
      }
    }
  }
  return $rc;
}

# end of ClearCase::Wrapper::MGi::_Mkbco
1;
