# NOTE: Derived from blib/lib/ClearCase/Wrapper/MGi.pm.
# Changes made here will be lost when autosplit is run again.
# See AutoSplit.pm.
package ClearCase::Wrapper::MGi;

#line 3870 "blib/lib/ClearCase/Wrapper/MGi.pm (autosplit into blib/lib/auto/ClearCase/Wrapper/MGi/annotate.al)"
sub annotate {
  use strict;
  use warnings;
  my (%opt, %ignore, %out);
  GetOptions(\%out, qw(line grep=s));
  GetOptions(\%ignore, qw(all rm));
  GetOptions(\%opt, qw(nco out=s));
  $ARGV[0] = 'annotate'; #make 'ct an' work
  my $ann = ClearCase::Argv->new(@ARGV);
  $ann->parse(qw(short|long fmt=s rmfmt=s nheader ndata force));
  my $fout = ($opt{out} and $opt{out} ne '-')? $opt{out} : '';
  die Msg('E', "Incompatible options.") if keys %out and ($ann->opts or $fout);
  my @args = $ann->args;
  die Msg('E', "$fout must be a directory") if $fout and @args>1 and !-d $fout;
  my @dirs = grep {-d $_} @args;
  if (@dirs) {
    @args = grep {!-d $_} @args;
    if (!$ann->flag('ndata') and !keys %out) {
      warn Msg('E', "Version has no data $_") for @dirs;
      die "\n" unless @args;
    }
  }
  $CT = new ClearCase::Argv({autochomp=>1});
  my $re = $out{grep}? qr/$out{grep}/ : '';
  if (@dirs) {
    my $rc = 0;
    if (keys %out) {
      for my $d (@dirs) {
	my %t;
	for ($CT->lshis([qw(-d -fmt), '%Nd %Vn %u %o:%Nc\n'], $d)->qx) {
	  if(/^([^:]+):(.*)$/) {
	    push @{$t{$1}}, $2;
	  } else {
	    push @{$t{$1}}, $_;
	  }
	}
	if ($re) {
	  for my $k (reverse sort keys %t) {
	    print "$k $_\n" for grep /$re/, @{$t{$k}};
	  }
	} else {
	  for my $k (reverse sort keys %t) {
	    print "$k $_\n" for @{$t{$k}};
	  }
	}
      }
    } else {
      my @opts = $ann->opts;
      $ann->opts('-out', $opt{out}, @opts) if $opt{out};
      $rc = $ann->args(@dirs)->system;
      $ann->opts(@opts);
    }
    exit $rc unless @args;
  }
  if (!$opt{nco}) {
    my @co = $CT->lsco([qw(-cview -s)], @args)->qx;
    if (@co) {
      @args = grep {!$CT->lsco([qw(-cview -s)], $_)->qx} @args;
      warn Msg('E',
	       "You may not annotate a checked-out version (use -nco flag): $_")
	for @co;
      die "\n" unless @args;
    }
  }
  if (keys %out) {
    $ENV{CLEARCASE_TAB_SIZE} = 2 unless $ENV{CLEARCASE_TAB_SIZE};
    no warnings qw(qw);
    my $fmt = $ENV{CCMGI_ANNF} || '%Sd %25.-25Vn %-9.9u,|,%Sd %25.-25Vn %-9.9u';
    $ann->opts(qw(-all -out - -nhe -rmf), ' D ', '-fmt', $fmt);
    $opt{out} = '-';
  } else {
    $ann->opts(qw(-all -out -), $ann->opts);
  }
  $ann->opts('-nco', $ann->opts) if $opt{nco};
  my $dir = -d $fout? $fout : '';
  my $rc = 0;
  for my $a (@args) {
    my @out = $ann->args($a)->qx;
    my @mver = grep{s%^\s+-> (\S+)$%$1%} $CT->lsvtree([qw(-s -merge)], $a)->qx;
    my %add;
    for my $v (@mver) { #versions merged to
      next if $v =~ /CHECKEDOUT$/; #annotate works only on checked-in versions
      my $ev = "$a\@\@$v";
      my ($prd) = grep{s/^<- (.*)/$1/} $CT->des([qw(-s -ahl Merge)], $ev)->qx;
      my @new = grep{s%^>\s+(.*)$%$1%} $CT->diff(['-diff'], $prd, $ev)->qx;
      $add{$v}->{$_}++ for @new;
    }
    if (keys %out) {
      map {s/^(\d\S+\s+\S+ \S+\s+)U /$1  /} @out;
      my @prune = @out;
      @out = ();
      for (@prune) {
	if (/^\S+\s+(\S+) \S+\s+(?:D\s+)?(.*)$/) {
	  push @out, $_ if !defined($add{$1}) or $add{$1}->{$2};
	} else {
	  push @out, $_;
	}
      }
    } else {
      map {s/ UNRELATED /           /} @out;
    }
    if ($opt{out} and $opt{out} eq '-') {
      if ($re) {
	my $pfl = $ENV{CCMGI_ANNL} || 49; # format length: 10 + 1 + 25 + 9 + 3
	print for grep {substr($_, $pfl) =~ /$re/} @out;
      } else {
	print for @out;
      }
    } else {
      require File::Slurp;
      require File::Basename;
      File::Basename->import('basename');
      require File::Spec;
      my $f = "$a.ann";
      $f = ($dir? File::Spec->catfile($dir, basename($f)): $fout) if $fout;
      $rc |= File::Slurp::write_file($f, @out);
      print qq(Annotated result written to "$f".\n);
    }
  }
  exit $rc;
}

# end of ClearCase::Wrapper::MGi::annotate
1;
