# NOTE: Derived from blib/lib/ClearCase/Wrapper/MGi.pm.
# Changes made here will be lost when autosplit is run again.
# See AutoSplit.pm.
package ClearCase::Wrapper::MGi;

#line 3050 "blib/lib/ClearCase/Wrapper/MGi.pm (autosplit into blib/lib/auto/ClearCase/Wrapper/MGi/describe.al)"
sub describe {
  use strict;
  use warnings;
  my $desc = ClearCase::Argv->new(@ARGV);
  $desc->optset(qw(CC WRAPPER));
  $desc->parseCC(qw(g|graphical local l|long s|short
		    fmt=s alabel=s aattr=s ahlink=s ihlink=s
		    cview version=s ancestor
		    predecessor pname type=s cact));
  $desc->parseWRAPPER(qw(parents|par9999=i family=i));
  my $generations = abs($desc->flagWRAPPER('parents') || 0);
  my @args = $desc->args;
  if (grep /^-par/, @args) {
    @args = grep !/^-par/, @args;
    $generations = 1;
  }
  my $rc = 0;
  if ($generations) {
    die Msg('E', 'incompatible flags: "parents" and "family"')
      if $desc->flagWRAPPER('family');
    $CT = new ClearCase::Argv({autochomp=>1});
    my @nargs;
    for my $arg (@args) {
      my $i = $generations;
      my ($ver, $type) =
	$CT->des([qw(-fmt %En@@%Vn\n%m)], $arg)->qx;
      if (!defined($type) or ($type !~ /version$/)) {
	warn Msg('W', "Not a version: $arg");
	next;
      }
      $ver =~ s%\\%/%g;
      my $ele = $ver;
      $ele =~ s%^(.*?)\@.*%$1%; # normalize in case of vob root directory
      my $gen = _DepthGen($ele, $i, $ver);
      my @p = @{$gen->{$ver}{'parents'}};
      while (@p and --$i) {
	my %q;
	for (@p) {
	  $q{$_}++ for @{$gen->{$_}{'parents'}};
	}
	@p = keys %q;
      }
      push(@nargs, @p) if @p;
    }
    scalar @nargs? $desc->args(@nargs) : exit 0; # avoid fallback!
  } else {
    if (defined($desc->flagWRAPPER('family')) or grep /^-fam/, @args) {
      my $nr;
      if (grep /^-fam/, @args) {
	@args = grep !/^-fam/, @args;
	$nr = 0;
      } else {
	$nr = abs($desc->flagWRAPPER('family'));
      }
      my @nargs;
      for my $t (@args) {
	if ($t =~ /^lbtype:.*?(@.*)?$/) {
	  my $v = $1? $1 : '';
	  my @l = _EqLbTypeList($t);
	  $nr = $#l if $nr and $nr > $#l;
	  push @nargs, "lbtype:$_$v" for $nr?(@l)[0..$nr-1]:@l;
	} else {
	  warn Msg('E', "Unable to access '$t': 'lbtype:' prefix required");
	  $rc = 1;
	}
      }
      @nargs? $desc->args(@nargs) : exit $rc; # avoid fallback!
    } elsif (my $fmt = $desc->flagCC('fmt')) {
      if ($fmt =~ s/\%P([VS]n)/\%$1/) {
	my $farg = 0;
	for (@{$desc->{AV_OPTS}{CC}}) {
	  if ($farg) {
	    $_ = $fmt;
	    last;
	  } else {
	    $farg = 1 if /^-fmt$/;
	  }
	}
	$desc->{AV_LKG}{CC}{fmt} = $fmt; # for possible further processing
	$CT = new ClearCase::Argv({autochomp=>1});
	my @nargs;
	for my $arg (@args) {
	  my $i = $generations;
	  my ($ver, $type) =
	    $CT->des([qw(-fmt %En@@%Vn\n%m)], $arg)->qx;
	  if (!defined($type) or ($type !~ /version$/)) {
	    warn Msg('W', "Not a version: $arg");
	    next;
	  }
	  $ver =~ s%\\%/%g;
	  my $ele = $ver;
	  $ele =~ s%^(.*?)\@.*%$1%; # normalize in case of vob root directory
	  my $gen = _DepthGen($ele, 1, $ver);
	  my @p = @{$gen->{$ver}{'parents'}};
	  push(@nargs, @p) if @p;
	}
	scalar @nargs? $desc->args(@nargs) : exit 0; # avoid fallback!
      }
    }
  }
  if (my $fmt = $desc->flagCC('fmt')) { # Maybe already modified
    my $ph = 'PlAcEhOlDeR';
    if ($fmt =~ s/\%\[(.*?)\](N?)l/$ph/) {
      my ($re, $ncom) = (qr($1), $2);
      my @args = $desc->args;
      my $fix = 0;
      for (@{$desc->{AV_OPTS}{CC}}) {
	$fix++;
	last if /^-fmt$/;
      }
      $CT = new ClearCase::Argv({autochomp=>1}) unless $CT;
      for (@args) {
	my @lb = grep /$re/, split / /, $CT->des([qw(-fmt %Nl)], $_)->qx;
	my $lb = $ncom? join(' ', @lb) : @lb? '(' . join(', ', @lb) . ')' : '';
	(my $f = $fmt) =~ s/$ph/$lb/;
	$desc->{AV_OPTS}{CC}->[$fix] = $f;
	$rc |= $desc->args($_)->system('CC');
      }
      exit $rc;
    }
  }
  $rc |= $desc->system('CC');
  exit $rc; # avoid fallback!
}

# end of ClearCase::Wrapper::MGi::describe
1;
