# NOTE: Derived from blib/lib/ClearCase/Wrapper/MGi.pm.
# Changes made here will be lost when autosplit is run again.
# See AutoSplit.pm.
package ClearCase::Wrapper::MGi;

#line 1985 "blib/lib/ClearCase/Wrapper/MGi.pm (autosplit into blib/lib/auto/ClearCase/Wrapper/MGi/lock.al)"
sub lock {
  use warnings;
  use strict;
  my (%opt, $nusers);
  GetOptions(\%opt, qw(allow=s deny=s iflocked));
  GetOptions('nusers=s' => \$nusers);
  my $lock = ClearCase::Argv->new(@ARGV);
  $lock->parse(qw(c|cfile=s cquery|cqeach nc pname=s obsolete replace));
  die Msg('E', "cannot specify -nusers along with -allow or -deny")
    if %opt and $nusers;
  die Msg('E', "cannot use -allow or -deny with multiple objects")
    if %opt and $lock->args > 1;
  my $lslock = ClearCase::Argv->lslock([qw(-fmt %c)], $lock->args);
  my($currlock) = $lslock->autofail(1)->qx;
  if ($currlock && $currlock =~ m%^Locked except for users:\s+(.*)%) {
    my %nusers = map {$_ => 1} split /\s+/, $1;
    if ($nusers) {
      %nusers = ();
      map { $nusers{$_} = 1 } split /,/, $nusers;
    } else {
      if ($opt{allow}) {
	map { $nusers{$_} = 1 } split /,/, $opt{allow};
      } elsif ($opt{deny}) {
	map { delete $nusers{$_} } split /,/, $opt{deny};
      } else {
	%nusers = ();
      }
    }
    $lock->opts($lock->opts, '-nusers', join(',', sort keys %nusers))
      if %nusers;
  } elsif (($nusers or $opt{allow}) and
	     (!$currlock or $opt{iflocked} or $lock->flag('replace'))) {
    $lock->opts($lock->opts, '-nusers', ($nusers or $opt{allow}));
  }
  if ($currlock and !$lock->flag('replace')) {
    if ($opt{allow} or $opt{deny}) {
      $lock->opts($lock->opts, '-replace')
    } else {
      die Msg('E', 'Object is already locked.');
    }
  }
  my @args = $lock->args;
  $CT = ClearCase::Argv->new({autochomp=>1});
  my (@lbt, @oth, %vob);
  my $locvob = $CT->des(['-s'], 'vob:.')->stderr(0)->qx;
  foreach (@args) {
    if (/^lbtype:/) {
      my $t = $CT->des([qw(-fmt %Xn\n)], $_)->qx;
      if ($t and $CT->des([qw(-fmt %m)], $t)->stderr(0)->qx eq 'label type') {
	my ($t1, $v) = $t;
	$v = $2 if $t =~ s/lbtype:(.*)@(.*)$/$1/;
	$vob{$t} = $v;
	push @lbt, $t;
	my @et = grep s/^-> lbtype:(.*)@.*$/$1/,
	  $CT->des([qw(-s -ahl), $EQHL], $t1)->qx;
	if (@et) {
	  my ($e, $p) = ($et[0], '');
	  $vob{$e} = $vob{$t};
	  push @lbt, $e;
	  my @pt = grep s/^-> lbtype:(.*)@.*$/$1/,
	    $CT->des([qw(-s -ahl), $PRHL], "lbtype:$e\@$v")->qx;
	  if (@pt) {
	    $p = $pt[0];
	    if (!$CT->lslock(['-s'], "lbtype:$p\@$v")->stderr(0)->qx) {
	      push @lbt, $p;
	      $vob{$p} = $v;
	    }
	  }
	}
      }
    } else {
      push @oth, $_;
    }
  }
  my $rc = @oth? $lock->args(@oth)->system : 0;
  my ($fl, $loaded) = $ENV{FORCELOCK};
  for my $lt (@lbt) {
    my $v = $vob{$lt};
    my @out = $lock->args("lbtype:$lt\@$v")->stderr(1)->qx;
    if (grep /^cleartool: Error/, @out) {
      if ($fl and !$loaded) {
	my $fn = $fl; $fn =~ s%::%/%g; $fn .= '.pm';
	require $fn;
	$fl->import;
	$loaded = 1;
      }
      if (!$fl) {
	print @out;
	$rc = 1;
      } elsif (flocklt($lt, $v, $lock->flag('replace'),
		       ($nusers or $opt{allow}))) {
	$rc = 1;
      }
    } else {
      print @out;
    }
  }
  exit $rc;
}

# end of ClearCase::Wrapper::MGi::lock
1;
