# NOTE: Derived from blib/lib/ClearCase/Wrapper/MGi.pm.
# Changes made here will be lost when autosplit is run again.
# See AutoSplit.pm.
package ClearCase::Wrapper::MGi;

#line 976 "blib/lib/ClearCase/Wrapper/MGi.pm (autosplit into blib/lib/auto/ClearCase/Wrapper/MGi/lsgenealogy.al)"
sub lsgenealogy {
  use warnings;
  use strict;
  my %opt;
  GetOptions(\%opt, qw(short all fmt=s obsolete depth=i offspring));
  Assert(@ARGV > 1);		# die with usage msg if untrue
  die Msg('E', 'Incompatible flags: "short" and "fmt"')
    if $opt{short} and $opt{fmt};
  $opt{depth} = 0 if $opt{offspring} and !defined $opt{depth};
  shift @ARGV;
  my @argv = ();
  for (@ARGV) {
    $_ = readlink if -l && defined readlink;
    push @argv, MSWIN ? glob($_) : $_;
  }
  $CT = ClearCase::Argv->new({autofail=>0, autochomp=>1, stderr=>0});
  while (my $e = shift @argv) {
    my ($ver, $type) =
      $CT->des([qw(-fmt %En@@%Vn\n%m)], $e)->qx;
    if (!defined($type) or ($type !~ /version$/)) {
      warn Msg('W', "Not a version: $e");
      next;
    }
    $ver =~ s%\\%/%g;
    my $ele = $ver;
    $ele =~ s%^(.*?)\@.*%$1%; # normalize in case of vob root directory
    my $gen = (($opt{all} or $opt{fmt}) and defined $opt{depth})?
      _RecGen($ele, $ver, \%opt)
      : _Parsevtree($ele, $opt{obsolete}, $ver);
    _Printoffspring($ver, $gen, \%opt, 0) if $opt{offspring};
    _Setdepths($ver, 0, $gen);
    my %seen = ();
    _Printparents($ver, $gen, \%seen, \%opt, 0);
  }
  exit 0;
}

# end of ClearCase::Wrapper::MGi::lsgenealogy
1;
