# NOTE: Derived from blib/lib/ClearCase/Wrapper/MGi.pm.
# Changes made here will be lost when autosplit is run again.
# See AutoSplit.pm.
package ClearCase::Wrapper::MGi;

#line 3748 "blib/lib/ClearCase/Wrapper/MGi.pm (autosplit into blib/lib/auto/ClearCase/Wrapper/MGi/lstype.al)"
sub lstype {
  use strict;
  use warnings;
  my $lst = ClearCase::Argv->new(@ARGV);
  $lst->parse(qw(local long|short|nostatus fmt=s obsolete kind=s invob=s
		 unsorted));
  return 0 if $lst->flag('local') or $lst->flag('long') and $lst->flag('fmt')
    or !$lst->flag('kind') or $lst->flag('kind') ne 'lbtype'
      or (grep/^-[ls]|nos/, $lst->opts) > 1;
  $CT = new ClearCase::Argv({autochomp=>1});
  my $v = $lst->flag('invob') || '.';
  return 0 if $CT->des([qw(-s -ahl AdminVOB)], "vob:$v")->qx;
  my (@lopts, @dopts) = ();
  push @lopts, qw(-local -kind lbtype -nostatus),
    grep{defined} ($lst->flag('obsolete') and '-obs'),
      ($lst->flag('invob') and ('-invob', $lst->flag('invob'))),
	($lst->flag('unsorted') and '-uns');
  my $sil = $CT->clone({stderr=>0});
  my $err = $CT->clone({stdout=>0, stderr=>1});
  my $lock = !grep /-nos/, $lst->opts;
  my $fmt = $lst->flag('fmt');
  push @dopts, grep{defined} grep(/^-[sl]/, $lst->opts), $fmt && ('-fmt', $fmt);
  push @dopts, '-s' unless $lock; #i.e. if -nostatus
  $lst->opts(@lopts);
  my $ext = $lst->flag('invob')? '@' . $lst->flag('invob') : '';
  my $cb = sub {
    my $t = shift; $t =~ y/\r//d; chomp $t;
    my $lbt = "lbtype:${t}$ext";
    if (my $e = $err->des(['-s'], $lbt)->qx) {
      if (my @l = grep{s/^\s+(G.*?)\s.*$/hlink:$1/}
	    $CT->des([qw(-l -local -ahl GlobalDefinition)], $lbt)->qx) {
	my %oid;
	for ($CT->dump($l[0])->qx) {
	  $oid{$1} = $2 if /^\s+to (\w+)=(.*)$/;
	}
	if ($oid{vob} and $oid{obj}) {
	  my $vob = $sil->lsvob([qw(-s -fam), $oid{vob}])->qx;
	  if ($vob) {
	    my $obj = $sil->des(['-s'], "oid:$oid{obj}\@$vob")->qx;
	    if (!$obj) {
	      warn Msg('W', "Could not find the global definition of "
			 . "'$t' in '$vob'. Synchronization issue?");
	    return 1;
	    }
	  } else {
	    warn Msg('W', "Could not find the vob containing the "
		       . "global definition for '$t': $oid{vob}");
	    return 1;
	  }
	}
      }
      print STDERR "$e\n";
    } else {
      my @opts = ($lock and $CT->lslock(['-s'], $lbt)->qx)?
	('-fmt', '%n (%[locked]p)\n') : @dopts;
      $CT->des([@opts], $lbt)->system;
    }
    return 1;			#continue
  };
  $lst->pipecb($cb);
  $lst->pipe; # no fallback!
  exit 0;
}

# end of ClearCase::Wrapper::MGi::lstype
1;
